// ѥ WASTE Proxy Object
// ѥ by Chris K. Thomas, ckt@guest.apple.com
// ѥ a proxy object is one that represents an object
// ѥ which cannot be displayed, due to memory, system software, or whatever

// ѥ 4 Jun 95 ckt

// ѥ Includes

#include "WEProxy.h"		// ѥ ourself

// ѥ Macros

#define ThrowIfOSErr_(x) if(x != noErr) goto Exit

// ѥ Constants

static const short kIconSize = 32;
static const short kIconStartID = 1024;
static const short kNumIcons = 5;

// ѥ Instance Variables

// ѥ Static Prototypes

static pascal OSErr	HandleNewProxy(Point *defaultObjectSize, WEObjectReference objectRef);
static pascal OSErr	HandleDispose3D(WEObjectReference objectRef );
static pascal OSErr	HandleDraw3D(Rect *destRect, WEObjectReference objectRef );

static UniversalProcPtr	sNew3DRD;
static UniversalProcPtr	sDispose3DRD;
static UniversalProcPtr	sDraw3DRD;

// ѥ Installer

OSErr WEObjProxyInstall(FlavorType inDataFlavor, inWEHandle inWaste)
{
	OSErr theErr = noErr;
	
	// * mixed mode magic
	
	if(sNew3DRD == NULL)
	{
		sNew3DRD = NewWENewObjectProc(HandleNew3D);
		sDispose3DRD = NewWEDisposeObjectProc(HandleDispose3D);
		sDraw3DRD = NewWEDrawObjectProc(HandleDraw3D);
	}
	
	// * install
	
	theErr = WEInstallObjectHandler(inDataFlavor, weNewHandler, sNew3DRD, inWaste);
	ThrowIfOSErr_(theErr);
	
	theErr = WEInstallObjectHandler(inDataFlavor, weDisposeHandler, sDispose3DRD, inWaste);
	ThrowIfOSErr_(theErr);
	
	theErr = WEInstallObjectHandler(inDataFlavor, weDrawHandler, sDraw3DRD, inWaste);
	ThrowIfOSErr_(theErr);

Exit:	
	return theErr;
}

// ѥ New handler
pascal OSErr	HandleNewProxy(Point *outDefaultSize, WEObjectReference inObjectRef)
{
	OSErr			theErr = noErr;
	
	outDefaultSize->h = kIconSize;
	outDefaultSize->v = kIconSize;
	
	WESetObjectRefCon(0, inObjectRef);
	
Exit:
	return theErr;
}

// ѥ Dispose handler
pascal OSErr	HandleDispose3D(WEObjectReference inObjectRef)
{
	OSErr			theErr = noErr;
	ViewerObject	curViewer;
	Handle			data;
	
	// * dispose data
	data = WEGetObjectDataHandle(objectRef);
	DisposeHandle(data);
	
	return theErr;
}

// ѥ Draw handler
pascal OSErr	HandleDraw3D (Rect *inDestRect, WEObjectReference inObjectRef)
{
	OSErr			theErr = noErr;
	WEHandle		ourWE;
	ViewerObject	curViewer;
	
	// * retrieve port
	curViewer = (ViewerObject)WEGetObjectRefCon(inObjectRef);
	
	// * use new rectangle
	theErr = Q3ViewerSetBounds(curViewer, inDestRect);
	ThrowIfOSErr_(theErr);
	  DrawS r
	// * draw
	theErr = Q3ViewerDraw(curViewer);
	
Exit:
	return theErr;
}